import {
  Body,
  Controller,
  Delete,
  Get,
  Patch,
  Path,
  Post,
  Request,
  Route,
  Security,
  Tags,
} from "tsoa";
import { AppDataSource } from "../database/data-source";
import HttpSuccess from "../interfaces/http-success";
import HttpStatus from "../interfaces/http-status";
import HttpError from "../interfaces/http-error";
import { ProfileDutyHistory } from "../entities/ProfileDutyHistory";
import { RequestWithUser } from "../middlewares/user";
import { ProfileEmployee } from "../entities/ProfileEmployee";
import { CreateProfileEmployeeDuty, ProfileDuty, UpdateProfileDuty } from "../entities/ProfileDuty";
import permission from "../interfaces/permission";
import { setLogDataDiff } from "../interfaces/utils";
@Route("api/v1/org/profile-employee/duty")
@Tags("ProfileEmployeeDuty")
@Security("bearerAuth")
export class ProfileDutyEmployeeController extends Controller {
  private profileRepository = AppDataSource.getRepository(ProfileEmployee);
  private dutyRepository = AppDataSource.getRepository(ProfileDuty);
  private dutyHistoryRepository = AppDataSource.getRepository(ProfileDutyHistory);

  @Get("user")
  public async getDutyUser(@Request() request: { user: Record<string, any> }) {
    const profile = await this.profileRepository.findOneBy({ keycloak: request.user.sub });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    const lists = await this.dutyRepository.find({
      where: { profileEmployeeId: profile.id, isDeleted: false },
      order: { createdAt: "ASC" },
    });
    return new HttpSuccess(lists);
  }

  @Get("{profileId}")
  public async getDuty(@Path() profileId: string, @Request() req: RequestWithUser) {
    let _workflow = await new permission().Workflow(req, profileId, "SYS_REGISTRY_EMP");
    if (_workflow == false)
      await new permission().PermissionOrgUserGet(req, "SYS_REGISTRY_EMP", profileId);
    const lists = await this.dutyRepository.find({
      where: { profileEmployeeId: profileId, isDeleted: false },
      order: { createdAt: "ASC" },
    });
    return new HttpSuccess(lists);
  }

  @Get("admin/history/{dutyId}")
  public async dutyAdminHistory(@Path() dutyId: string, @Request() req: RequestWithUser) {
    const _record = await this.dutyRepository.findOneBy({ id: dutyId });
    if (_record) {
      let _workflow = await new permission().Workflow(req, dutyId, "SYS_REGISTRY_EMP");
      if (_workflow == false)
        await new permission().PermissionOrgUserGet(
          req,
          "SYS_REGISTRY_EMP",
          _record.profileEmployeeId,
        );
    }
    const record = await this.dutyHistoryRepository.find({
      where: { profileDutyId: dutyId },
      order: { createdAt: "DESC" },
    });
    return new HttpSuccess(record);
  }

  @Get("history/{dutyId}")
  public async dutyHistory(@Path() dutyId: string) {
    const record = await this.dutyHistoryRepository.find({
      where: { profileDutyId: dutyId },
      order: { createdAt: "DESC" },
    });
    return new HttpSuccess(record);
  }

  @Post()
  public async newDuty(@Request() req: RequestWithUser, @Body() body: CreateProfileEmployeeDuty) {
    if (!body.profileEmployeeId) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "กรุณากรอก profileId");
    }

    const profile = await this.profileRepository.findOneBy({ id: body.profileEmployeeId });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    await new permission().PermissionOrgUserUpdate(req, "SYS_REGISTRY_EMP", profile.id);
    const before = null;
    const data = new ProfileDuty();

    const meta = {
      createdUserId: req.user.sub,
      createdFullName: req.user.name,
      lastUpdateUserId: req.user.sub,
      lastUpdateFullName: req.user.name,
      createdAt: new Date(),
      lastUpdatedAt: new Date(),
    };

    Object.assign(data, { ...body, ...meta });
    const history = new ProfileDutyHistory();
    Object.assign(history, { ...data, id: undefined });

    await this.dutyRepository.save(data, { data: req });
    setLogDataDiff(req, { before, after: data });
    history.profileDutyId = data.id;
    await this.dutyHistoryRepository.save(history, { data: req });
    //setLogDataDiff(req, { before, after: history });

    return new HttpSuccess(data.id);
  }

  @Patch("{dutyId}")
  public async editDuty(
    @Request() req: RequestWithUser,
    @Body() body: UpdateProfileDuty,
    @Path() dutyId: string,
  ) {
    const record = await this.dutyRepository.findOneBy({ id: dutyId });
    if (!record) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    await new permission().PermissionOrgUserUpdate(
      req,
      "SYS_REGISTRY_EMP",
      record.profileEmployeeId,
    );
    const before = structuredClone(record);
    const before_null = null;
    const history = new ProfileDutyHistory();

    Object.assign(record, body);
    Object.assign(history, { ...record, id: undefined });

    history.profileDutyId = dutyId;
    record.lastUpdateUserId = req.user.sub;
    record.lastUpdateFullName = req.user.name;
    record.lastUpdatedAt = new Date();
    history.lastUpdateUserId = req.user.sub;
    history.lastUpdateFullName = req.user.name;
    history.createdUserId = req.user.sub;
    history.createdFullName = req.user.name;
    history.createdAt = new Date();
    history.lastUpdatedAt = new Date();

    this.dutyRepository.save(record, { data: req });
    setLogDataDiff(req, { before, after: record });
    if (!(Object.keys(body).length === 1 && body.isUpload)) {
      this.dutyHistoryRepository.save(history, { data: req });
      // setLogDataDiff(req, { before, after: history });
    }

    return new HttpSuccess();
  }

  /**
   * API ลบข้อมูลปฏิบัติราชการพิเศษ
   * @summary API ลบข้อมูลปฏิบัติราชการพิเศษ
   * @param dutyId คีย์ปฏิบัติราชการพิเศษ
   */
  @Patch("update-delete/{dutyId}")
  public async updateIsDeleted(
    @Request() req: RequestWithUser,
    @Path() dutyId: string,
  ) {
    const record = await this.dutyRepository.findOneBy({ id: dutyId });
    if (!record) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    if (record.isDeleted === true) {
      return new HttpSuccess();
    }
    await new permission().PermissionOrgUserDelete(req, "SYS_REGISTRY_EMP", record.profileEmployeeId);
    const before = structuredClone(record);
    const history = new ProfileDutyHistory();
    const now = new Date();
    record.isDeleted = true;
    record.lastUpdateUserId = req.user.sub;
    record.lastUpdateFullName = req.user.name;
    record.lastUpdatedAt = now;

    Object.assign(history, { ...record, id: undefined });
    history.profileDutyId = dutyId;
    history.createdUserId = req.user.sub;
    history.createdFullName = req.user.name;
    history.createdAt = now;

    await Promise.all([
      this.dutyRepository.save(record, { data: req }),
      setLogDataDiff(req, { before, after: record }),
      this.dutyHistoryRepository.save(history, { data: req }),
    ]);

    return new HttpSuccess();
  }

  @Delete("{dutyId}")
  public async deleteDuty(@Path() dutyId: string, @Request() req: RequestWithUser) {
    const _record = await this.dutyRepository.findOneBy({ id: dutyId });
    if (_record) {
      await new permission().PermissionOrgUserDelete(
        req,
        "SYS_REGISTRY_EMP",
        _record.profileEmployeeId,
      );
    }
    await this.dutyHistoryRepository.delete({
      profileDutyId: dutyId,
    });

    const result = await this.dutyRepository.delete({ id: dutyId });

    if (result.affected == undefined || result.affected <= 0) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }

    return new HttpSuccess();
  }
}
